﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.01
@EndOfDesignText@
Sub Class_Globals
	
	Private Const RED As Int = 0
	Private Const BLACK As Int = 1
	Private Const NOCOLOR As Int = - 2
	Private RootNode As TreeNode
	Private NullNode As TreeNode
	Private NOCOLORNODE As TreeNode
	Private NodeCount As Int = 0
	Private NavigatorList As List
	Private ComparatorInstance As Object = Null
	Private CompatatorSub As String = Null
End Sub

'Inatalizes the map. To use a custom key sort pass an instance of a class as the Comparator and the name of the sub in the class which
'performs the key comparison. Pass null to use the default string comparison
'
'Example sort sub:
'
'Sub IntSort(Key1 As Object,Key2 As Object) As Int
'	Dim Key1i As Int = Key1
'	Dim Key2i As Int = Key2
'	
'	If Key1i > Key2i Then
'		Return 1
'	Else If Key1i < Key2i Then
'		Return -1
'	Else
'		Return 0
'	End If
'End Sub



Public Sub Initialize(Comparator As Object,SubToCall As String)
	Dim NNode As TreeNode
	Dim NCNODE As TreeNode
	NNode.Initialize(Null,Null,Null,Null)

	NullNode = NNode
	NullNode.Parent = NullNode
	NullNode.Color = NOCOLOR
	RootNode = NullNode
	NCNODE.Initialize(Null,Null,Null,Null)

	NOCOLORNODE = NCNODE
	NOCOLORNODE.Parent = NullNode
	NOCOLORNODE.Color = BLACK
	NavigatorList.Initialize
	ComparatorInstance = Comparator
	CompatatorSub = SubToCall
	
	

End Sub



'******************************************************************************************************'
'*																									  *'
'* 	Basic Map methods: Put,Remove, Get, Contains etc,												  *'
'* 																				                      *
'*																									  *
'******************************************************************************************************'







'Puts a key/value pair in the map, overwriting the previous item with this key (if such exists).
Public Sub Put(Key As Object, Value As Object)
   
	'If NodeCount is zero then create an new node
	If NodeCount = 0 Then
		Dim NewNode As TreeNode
		NewNode.Initialize(Key,Value,NullNode,NullNode)
		NewNode.Color = BLACK
		RootNode = NewNode
		RootNode.Parent = NullNode
		NodeCount = NodeCount + 1
		Return
	End If
	

    
	'Insert leaf node with new key value
	Dim InsertNode As TreeNode = RootNode
	 
	Do While InsertNode <> NullNode
		If (CompareKey(Key,InsertNode.Key) < 0) Then
			If InsertNode.Left<> NullNode Then
				InsertNode = InsertNode.Left
			Else
				Exit
			End If
		Else If (CompareKey(Key,InsertNode.Key) > 0) Then
			If InsertNode.Right <> NullNode Then
				InsertNode = InsertNode.Right
			Else
			
				Exit
			End If
		Else
			'Key Already Exists so just update the value
			InsertNode.Value = Value
			Return
			
		End If
	Loop
	
	Dim NewNode As TreeNode
	NewNode.Initialize(Key,Value,NullNode,NullNode)
	If (CompareKey(Key,InsertNode.Key) < 0) Then
		InsertNode.Left= NewNode
		NewNode.Parent = InsertNode
		NewNode.Color = RED
		FixNodesInsert(NewNode)
		
		NodeCount = NodeCount + 1
	Else If  (CompareKey(Key,InsertNode.Key) > 0) Then
		InsertNode.Right = NewNode
		
		NewNode.Parent = InsertNode
		NewNode.Color = RED
		FixNodesInsert(NewNode)
		NodeCount = NodeCount + 1
	Else
		InsertNode.Value = Value
	
	
	End If
	InformNavigatorsAdd
	
End Sub
'Removes all of the mappings from this map.	


'Removes the Key form The Map
Public Sub Remove(Key As Object)
	
	Dim NodeToDelete As TreeNode = RootNode
	Dim ChildNode As TreeNode = NullNode
	Dim NodeFound As Boolean = False
	Do While NodeToDelete <> NullNode
		If (CompareKey(Key,NodeToDelete.Key) < 0) Then
			If NodeToDelete.Left<> NullNode Then
				NodeToDelete = NodeToDelete.Left
			Else
				Return
			End If
		Else If (CompareKey(Key,NodeToDelete.Key) > 0) Then
			If NodeToDelete.Right <> NullNode Then
				NodeToDelete = NodeToDelete.Right
			Else
				Return
			End If
		Else
			NodeFound = True
			Exit
			
		End If
	Loop
	
	If NodeFound = True Then
         InformNavigatorsDeletion(NodeToDelete)
		'Deletion for no child nodes
		If NodeToDelete.Left= NullNode And NodeToDelete.Right = NullNode Then
			If NodeToDelete.Parent.Left= NodeToDelete Then
				NodeToDelete.Parent.Left= NOCOLORNODE
				NOCOLORNODE.Parent =  NodeToDelete.Parent
		
				NodeToDelete.Parent.Left = NullNode
			Else
				NodeToDelete.Parent.Right = NOCOLORNODE
				NOCOLORNODE.Parent =  NodeToDelete.Parent
				NodeToDelete.Parent.Right = NullNode
			End If
			NOCOLORNODE.Parent = Null
	   
			NodeToDelete.Parent = Null
			NodeToDelete.Left= Null
			NodeToDelete.Right = Null
			NodeToDelete.Value = Null
			NodeToDelete.Key = Null
	   
			'Deletion for one child node
		Else If (NodeToDelete.Left= NullNode And NodeToDelete.Right <> NullNode) Or (NodeToDelete.Left<> NullNode And NodeToDelete.Right = NullNode) Then
			'NodeToDelete has Right Child
			If NodeToDelete.Left= NullNode Then
				ChildNode = NodeToDelete.Right
				NodeToDelete.Parent.Right = NodeToDelete.Right
				NodeToDelete.Right.Parent = NodeToDelete.Parent
			
			Else
				'NodeToDelete has LeftChild
				ChildNode = NodeToDelete.Left
				NodeToDelete.Parent.Left = NodeToDelete.Left
				NodeToDelete.Left.Parent = NodeToDelete.Parent
			
			End If
			
			
			
			NodeToDelete.Parent = Null
			NodeToDelete.Left= Null
			NodeToDelete.Right = Null
			NodeToDelete.Value = Null
			NodeToDelete.Key = Null
		Else
			'Deletion for two child nodes
			'Find the minimum value key below NodeToDelete
			Dim SwapNode As TreeNode = FindMinFromNode(NodeToDelete)
			'Swap The Value And Key form that node
			NodeToDelete.Value = SwapNode.Value
			NodeToDelete.Key = SwapNode.Key
			'Finally Remove the miminum node
			'No need to recoulour tree
	  
	  
			SwapNode.Parent.Left= NullNode
			SwapNode.Parent = Null
			SwapNode.Left= Null
			SwapNode.Right = Null
			SwapNode.Value = Null
			SwapNode.Key = Null
	   
		End If
	
		If ChildNode <> NullNode Then
			FixNodesRemove(ChildNode)
		End If
		NodeCount = NodeCount -1
	End If
End Sub

'Returns the value of the item with the given Key.
Public Sub Get(Key As Object) As Object
	Dim CurrentNode As TreeNode = RootNode
	Do While CurrentNode <> NullNode
		Dim CompareResult As Int = CompareKey(Key,CurrentNode.key)
		If CompareResult < 0 Then
			CurrentNode = CurrentNode.Left
		Else If CompareResult > 0 Then
			CurrentNode = CurrentNode.Right
		Else
			Return CurrentNode.Value
		End If
	Loop
	Return  CurrentNode.Value
	
End Sub

'Tests whether there is an item with the given key.
Public Sub ContainsKey(Key As Object) As Boolean
	If Find(Key) <> Null Then
		Return True
	Else
		Return False
	End If
 
 
End Sub

'Clears all items of the map
Public Sub Clear
	RootNode = Null
	NodeCount = 0
	
End Sub



'******************************************************************************************************'
'*																									  *'
'* 	Tree sorting  															                          *'
'* 																				                      *
'*																									  *
'******************************************************************************************************'
Private Sub CompareKey(Key1 As Object,Key2 As Object) As Int

 
	If  ComparatorInstance = Null Then
		Dim Key1S As String = Key1
		Dim Key2S As String = Key2
		Return Key1S.CompareTo(Key2S)
	Else
		Dim ReturnVal As Int = CallSub3(ComparatorInstance,CompatatorSub,Key1,Key2)
		Return ReturnVal
   
	End If
  
	
End Sub


'******************************************************************************************************'
'*																									  *'
'* 	Tree balancing methods 															                  *'
'* 																				                      *
'*																									  *
'******************************************************************************************************'
'Recolor and rotate nodes as per algorityhm rules
Private Sub FixNodesInsert(StartNode As TreeNode)
	
	Dim ParentNode As TreeNode
	Dim UncleNode As TreeNode = Null
	Dim GrandParentNode As TreeNode = Null
	Dim TmpColor As Int
	
	Do While StartNode <> RootNode And StartNode.Parent.Color = RED And StartNode.Color <> BLACK
		ParentNode = StartNode.Parent
		GrandParentNode = StartNode.Parent.Parent
		If (ParentNode = StartNode.Parent.Parent.Left) Then
      
            
			UncleNode =GrandParentNode.Right
			
			'The uncle of StartNode Is also RED Only ReColoring requiRED
			
			If  UncleNode <> NullNode And UncleNode.Color = RED Then
				
				StartNode.Parent.Parent.Color = RED
				ParentNode.Color = BLACK
				UncleNode.Color = BLACK
				StartNode =GrandParentNode
				
			Else
	           
				'*Start Node Is Right child of its Parent so rote rotate Left
				If StartNode = ParentNode.Right Then
					
					rotateLeft( ParentNode)
					StartNode=  ParentNode
					ParentNode = StartNode.Parent
				End If
				
				'Right rotate a StartNode is the Left child of its Parent
				rotateRight(StartNode.Parent.Parent)
				Dim TmpColor As Int =GrandParentNode.Color
				GrandParentNode.Color= StartNode.Color
				ParentNode.Color = TmpColor
				StartNode = StartNode.Parent
				
			End If
			
		Else
			UncleNode =GrandParentNode.Left
			If UncleNode = Null Then
				UncleNode = NullNode
			End If
			'	The uncle of StartNode Is also RED Only ReColoring requiRED
			If UncleNode  <> NullNode And UncleNode.Color = RED Then
				
				GrandParentNode.Color = RED
				ParentNode.Color = BLACK
				UncleNode.Color = BLACK
				StartNode =GrandParentNode
       
			Else
            
				'Start Node Is Right child of its Parent so rote rotate Right
				If (StartNode = ParentNode.Left) Then
					
					rotateRight(ParentNode)
					StartNode = ParentNode
					ParentNode = StartNode.Parent
              
				End If
				'StartNode Is Right child of its Parent so rotate Left
				rotateLeft(GrandParentNode)
				Dim TmpColor As Int =GrandParentNode.Color
				GrandParentNode.Color= StartNode.Color
				ParentNode.Color = TmpColor
				StartNode = StartNode.Parent
			End If
			
 
		
		
		End If
		
	Loop
		
	RootNode.Color = BLACK
	
End Sub

Private Sub FixNodesRemove(StartNode As TreeNode)

	Dim FixNode As TreeNode = StartNode
	Dim ColorNode As TreeNode = NullNode

	'While Tree isn't fixed
	Do While ( FixNode <> RootNode And FixNode.Color = BLACK)

		' If FixNode  Is it's Parent's Leftchild
		If FixNode = FixNode.Parent.Left Then

			' set ColorNode = FixNode's sibling
			ColorNode = FixNode.Parent.Right

			'ColorNode's Color is red.
			If (ColorNode.Color = RED) Then
				ColorNode.Color = BLACK
				FixNode.Parent.Color = RED
				rotateLeft(FixNode.Parent)
				ColorNode = FixNode.Parent.Right
			End If

			'Both of ColorNode's children are black
			If ColorNode.Left.Color = BLACK And ColorNode.Right.Color = BLACK Then
				ColorNode.Color = RED
				FixNode = FixNode.Parent
			Else
				' ColorNode's Right child is black
				If ColorNode.Right.Color = BLACK Then
					ColorNode.Left.Color = BLACK
					ColorNode.Color = RED
					rotateRight(ColorNode)
					ColorNode = FixNode.Parent.Right
				End If
				If ColorNode.Color = BLACK And ColorNode.Right.Color = RED Then
					ColorNode.Color = FixNode.Parent.Color
					FixNode.Parent.Color = BLACK
					ColorNode.Right.Color = BLACK
					rotateLeft(FixNode.Parent)
					FixNode = RootNode
				End If
			End If
		Else
			'FixNode Is it's Parent's Right child
			'set ColorNode To FixNode's sibling
					
			ColorNode = FixNode.Parent.Left

			'ColorNode's Color is red
			If ColorNode.Color = RED Then
				ColorNode.Color = BLACK
				FixNode.Parent.Color = RED
				rotateRight(FixNode.Parent)
				ColorNode = FixNode.Parent.Left
			End If
			If ColorNode.Right  <> Null And ColorNode.Left  <> Null Then
			'both of ColorNode's children are black
				If ColorNode.Right.Color = BLACK And ColorNode.Left.Color = BLACK Then
					ColorNode.Color = RED
					FixNode = FixNode.Parent
				Else
					'ColorNode's Leftchild is black
					If ColorNode.Left.Color = BLACK Then
						ColorNode.Right.Color = BLACK
						ColorNode.Color = RED
						rotateLeft(ColorNode)
						ColorNode = FixNode.Parent.Left
					End If
				 
					If  ColorNode.Color = BLACK And ColorNode.Left.Color = RED Then
						ColorNode.Color = FixNode.Parent.Color
						FixNode.Parent.Color = BLACK
						ColorNode.Left.Color = BLACK
						rotateRight(FixNode.Parent)
						FixNode = RootNode
					End If
				End If
			End If
		End If
	Loop

	'Set FixNode To Black To ensure no Red Black / Violation
	FixNode.Color = BLACK
							
End Sub
	

'******************************************************************************************************'
'*																									  *'
'* 	Tree node rotation methods																          *'
'* 																				                      *
'*																									  *
'******************************************************************************************************'
 Private Sub rotateLeft(RotationNode As TreeNode)
	If RotationNode <> Null And RotationNode <> NullNode Then
		Dim RightNode As TreeNode=  RotationNode.Right
		RotationNode.Right = RightNode.Left
		If (RightNode.Left <> NullNode) Then
			RightNode.Left.Parent =RotationNode
		End If
			RightNode.Parent = RotationNode.Parent
			If RotationNode.Parent = NullNode Then
				RootNode = RightNode
			else if RotationNode.Parent.Left = RotationNode Then
			      RotationNode.parent.Left = RightNode
			Else
			  
			    RotationNode.parent.Right = RightNode
			End If
				RightNode.Left = RotationNode
				RotationNode.parent = RightNode
		
	End If
End Sub

Private Sub rotateRight(RotationNode As TreeNode)
	
	If RotationNode <> Null And RotationNode <> NullNode Then
		Dim LeftNode As TreeNode=  RotationNode.Left
		RotationNode.Left = LeftNode.Right
		If (LeftNode.Right <> NullNode) Then
			LeftNode.Right.Parent = RotationNode
		End If
		LeftNode.Parent = RotationNode.Parent
		If RotationNode.Parent = NullNode Then
			RootNode = LeftNode
		else if RotationNode.Parent.Right = RotationNode Then
			RotationNode.Parent.Right = LeftNode
		Else
			RotationNode.Parent.Left = LeftNode
		End If
		LeftNode.Right = RotationNode
		RotationNode.parent = LeftNode
		
	End If
End Sub




 


'******************************************************************************************************'
'*																									  *'
'* 	Internal tree traversal methods																      *'
'* 																				                      *
'*																									  *
'******************************************************************************************************'

Private Sub Find(Key As Object) As TreeNode
 	
	Dim current As TreeNode = RootNode
 
	Do While CompareKey(Key,current.Key) <> 0
 
		If CompareKey(Key,current.Key) < 0 Then
			current = current.Left
		Else
			current = current.Right
		End If
		If current = NullNode Then
			Return Null
		End If
	Loop
	Return current

End Sub


Private Sub FindMinFromNode(StartNode As TreeNode) As TreeNode
	
	Dim MinNode As TreeNode
	MinNode = StartNode
	
	Do While MinNode.Left<> NullNode
		MinNode = MinNode.Left
		
	Loop
	Return MinNode
	
End Sub





Private Sub InOrderSuccessor(N As TreeNode)  As TreeNode
	If (N.Right <> NullNode) Then
		Return MinValue(n.Right)
	Else
		Dim Parent As TreeNode = N.Parent
		Do  While Parent <> NullNode And n = Parent.Right
			n = Parent
			Parent = Parent.Parent
		Loop
		Return Parent
	End If
End Sub
 
Private Sub InOrderPredescessor(N As TreeNode)  As TreeNode
	If (N.Left <> NullNode) Then
		Return MaxValue(n.Left)
	Else
		Dim Parent As TreeNode = N.Parent
		Do  While Parent <> NullNode And n = Parent.Left
			n = Parent
			Parent = Parent.Parent
		Loop
		Return Parent
	End If
End Sub

Private  Sub MaxValue(N As TreeNode) As TreeNode
	Dim CurrentNode As TreeNode = N
	Do While CurrentNode.Right <> NullNode
		CurrentNode = CurrentNode.Right
	Loop
	Return  CurrentNode
End Sub
 
Private  Sub MinValue(N As TreeNode) As TreeNode
	Dim CurrentNode As TreeNode = N
	Do While CurrentNode.Left <> NullNode
		CurrentNode = CurrentNode.Left
	Loop
	Return  CurrentNode
End Sub



'******************************************************************************************************'
'*																									  *'
'* 	Public methods extending map functionality													      *'
'* 																				                      *
'*																									  *
'******************************************************************************************************'

'Returns a TreeMap with the keys ordered by the comparator sub.
Public Sub ComparatorMap(Comparator As Object,SubToCall As String) As SortedMap
	Dim NewMap As SortedMap
	NewMap.Initialize(Comparator,SubToCall)
	CopyToMap(NewMap,RootNode)
	Return NewMap
	
	
End Sub

Private Sub CopyToMap(NewMap As SortedMap,Node As TreeNode)
	If Node = NullNode Then
		Return
	End If
	CopyToMap(NewMap,Node.Left)
	NewMap.Put(Node.Key,Node.Value)
	CopyToMap(NewMap,Node.Right)
End Sub

'Returns the least key greater than or equal to the given key, or null if there is no such key.
Public Sub CeilingKey (Key As Object) As Object
	Dim CurrentNode As TreeNode = RootNode
	Do While CurrentNode <>  NullNode
		Dim CompareResult As Int = CompareKey(Key, CurrentNode.Key)
		If CompareResult < 0 Then
			If CurrentNode.Left <> NullNode Then
				CurrentNode = CurrentNode.Left
			Else
				Return CurrentNode.Key
			End If
		Else If CompareResult > 0 Then
			If CurrentNode.Right <> NullNode Then
				CurrentNode = CurrentNode.Right
			Else
				Dim Parent As TreeNode = CurrentNode.Parent
				Dim Child As TreeNode = CurrentNode
				Do While Parent <> NullNode And Child = Parent.Right
					Child = Parent
					Parent = Parent.Parent
				Loop
				Return Parent.Key
			End If
		Else
			Return CurrentNode.Key
		End If
	Loop
	Return Null
End Sub
 
'Returns the greatest key less than or equal to the given key, or null if there is no such key.
Public Sub FloorKey (Key As Object) As Object
	Dim CurrentNode As TreeNode = RootNode
	Do While CurrentNode <>  NullNode
		Dim CompareResult As Int = CompareKey(Key, CurrentNode.Key)
		If CompareResult > 0 Then
			If CurrentNode.Right <> NullNode Then
				CurrentNode = CurrentNode.Right
			Else
				Return CurrentNode.Key
			End If
		Else If CompareResult < 0 Then
			If CurrentNode.Left <> NullNode Then
				CurrentNode = CurrentNode.Left
			Else
				Dim Parent As TreeNode = CurrentNode.Parent
				Dim Child As TreeNode = CurrentNode
				Do While Parent <> NullNode And Child = Parent.Left
					Child = Parent
					Parent = Parent.Parent
				Loop
				Return Parent.Key
			End If
		Else
			Return CurrentNode.Key
		End If
	Loop
	Return Null
End Sub

'Returns the first (lowest) key currently in this map.
Public Sub FirstKey() As Object
	Dim CurrentNode As TreeNode = RootNode
	If (CurrentNode <> NullNode) Then
		Do  While CurrentNode.Left <> NullNode
			CurrentNode =  CurrentNode.Left
		Loop
	End If
	Return CurrentNode.Key
End Sub

'Returns the last (highest) key currently in this map.
Public Sub LastKey() As Object
	Dim CurrentNode As TreeNode = RootNode
	If (CurrentNode <> NullNode) Then
		Do  While CurrentNode.Right <> NullNode
			CurrentNode =  CurrentNode.Right
		Loop
	End If
	Return CurrentNode.Key
End Sub



'Returns the number of items stored in the map.
Public Sub getSize() As Int
	Return NodeCount
End Sub

'Returns a view of the portion of this map whose keys are less than (or equal to if inclusive) the passed Key
Public Sub HeadMap(Key As Object,Inclusive As Boolean)  As SortedMap
	Dim CurrentNode As TreeNode = RootNode
	Do While CurrentNode.Left <>  NullNode
		CurrentNode = CurrentNode.Left
	Loop
	
	If CompareKey(CurrentNode.Key,Key) > 0 Then
		Return Null
	End If
	
	Dim TempMap As SortedMap
	TempMap.Initialize(ComparatorInstance,CompatatorSub)
	
	
	
	Do While CurrentNode <> NullNode
		If Inclusive = True Then
			If CompareKey(CurrentNode.Key,Key) > 0 Then
				Exit
			Else
				TempMap.Put(CurrentNode.Key,CurrentNode.Value)
			End If
		Else
			If CompareKey(CurrentNode.Key,Key) >= 0 Then
				Exit
			Else
				TempMap.Put(CurrentNode.Key,CurrentNode.Value)
			End If
		End If
		CurrentNode = InOrderSuccessor(CurrentNode)
		 
	Loop
	Return TempMap
End Sub

'Returns a TreeMap of the portion of this map whose keys are greater than (or equal to if inclusive) fromKey.
Public Sub TailMap(Key As Object,Inclusive As Boolean)  As SortedMap
	Dim CurrentNode As TreeNode = RootNode
	Do While CurrentNode.Right <>  NullNode
		CurrentNode = CurrentNode.Right
	Loop
	
	If CompareKey(CurrentNode.Key,Key) < 0 Then
		Return Null
	End If
	
	Dim TempMap As SortedMap
	TempMap.Initialize(ComparatorInstance,CompatatorSub)
	
	
	
	Do While CurrentNode <> NullNode
		If Inclusive = True Then
			If CompareKey(CurrentNode.Key,Key) < 0 Then
				Exit
			Else
				TempMap.Put(CurrentNode.Key,CurrentNode.Value)
			End If
		Else
			If CompareKey(CurrentNode.Key,Key) <= 0 Then
				Exit
			Else
				TempMap.Put(CurrentNode.Key,CurrentNode.Value)
			End If
		End If
		CurrentNode = InOrderPredescessor(CurrentNode)
		 
	Loop
	Return TempMap
End Sub




'Returns the least key strictly greater than the given key, or null if there is no such key.
Sub HigherKey(Key As Object) As Object
	Dim CurrentNode As TreeNode = RootNode
    
	Do While CurrentNode <>  NullNode
		Dim  ComparatorResult As Int = CompareKey(Key, CurrentNode.key)
          
		If ComparatorResult < 0 Then
			If CurrentNode.Left <> NullNode Then
				CurrentNode = CurrentNode.Left
			Else
				Return CurrentNode.Key
			End If
		Else
			If CurrentNode.Right <> NullNode  Then
				CurrentNode = CurrentNode.Right
			Else
				Dim Parent As TreeNode= CurrentNode.Parent
				Dim Child  As TreeNode = CurrentNode
				Do  While Parent <> NullNode And Child = Parent.Right
					Child = Parent
					Parent = Parent.Parent
				
				Loop
				Return Parent.Key
			End If
		End If
	Loop
	Return Null
End Sub

Private Sub HigherKeyNode(Key As Object) As TreeNode
	
	Dim CurrentNode As TreeNode = RootNode
    
	Do While CurrentNode <>  NullNode
		Dim  ComparatorResult As Int = CompareKey(Key, CurrentNode.key)
          
		If ComparatorResult < 0 Then
			If CurrentNode.Left <> NullNode Then
				CurrentNode = CurrentNode.Left
			Else
				Return CurrentNode
			End If
		Else
			If CurrentNode.Right <> NullNode  Then
				CurrentNode = CurrentNode.Right
			Else
				Dim Parent As TreeNode= CurrentNode.Parent
				Dim Child  As TreeNode = CurrentNode
				Do  While Parent <> NullNode And Child = Parent.Right
					Child = Parent
					Parent = Parent.Parent
				
				Loop
				Return Parent
			End If
		End If
	Loop
	Return Null
End Sub

'Returns the greatest key less than the given key, or null if there is no such key.
Public Sub LowerKey(Key As Object) As Object
	Dim CurrentNode As TreeNode = RootNode
    
	Do While CurrentNode <>  NullNode
		Dim  ComparatorResult As Int = CompareKey(Key, CurrentNode.key)
          
		If ComparatorResult > 0 Then
			If CurrentNode.Right <> NullNode Then
				CurrentNode = CurrentNode.Right
			Else
				Return CurrentNode.Key
			End If
		Else
			If CurrentNode.Right <> NullNode  Then
				CurrentNode = CurrentNode.Left
			Else
				Dim Parent As TreeNode= CurrentNode.Parent
				Dim Child  As TreeNode = CurrentNode
				Do  While Parent <> NullNode And Child = Parent.Left
					Child = Parent
					Parent = Parent.Parent
				
				Loop
				Return Parent.Key
			End If
		End If
	Loop
	Return Null
End Sub

'Returns a TreMmap of the portion of this map whose keys range from fromKey to toKey.
'The range Is inclusive of the Key values If inclusive Is True
Public Sub Submap(FromKey As Object,ToKey As Object,Inclusive As Boolean) As SortedMap
	Dim StartNode As TreeNode = HigherKeyNode(FromKey)
	Dim TempMap As SortedMap
	If StartNode = Null Then
		StartNode = Find(FromKey)
	End If
      
	If StartNode <> Null Then
		TempMap.Initialize(ComparatorInstance,CompatatorSub)
	
		
		Dim BeforeNode As TreeNode = InOrderPredescessor(StartNode)
		If BeforeNode <> Null Then
			If CompareKey(BeforeNode.Key,FromKey) = 0 And Inclusive = True Then
				StartNode = BeforeNode
			End If
		End If
	   
		Do While StartNode <> NullNode
			If Inclusive = True Then
				If CompareKey(StartNode.Key,ToKey) <= 0 Then
					TempMap.Put(StartNode.Key,StartNode.Value)
					StartNode = InOrderSuccessor(StartNode)
				Else
					Exit
				End If
			Else
				If CompareKey(StartNode.Key,ToKey) < 0 Then
					TempMap.Put(StartNode.Key,StartNode.Value)
					StartNode = InOrderSuccessor(StartNode)
				Else
					Exit
				End If
			End If
				
		Loop
		Return TempMap
	Else
		Return Null
	  	
		
	End If
 
End Sub




'******************************************************************************************************'
'*																									  *'
'* SortedMapNavigator methods. Registers and deregistera navigatorsand informs navigators of Put and  *'
'* Remove operations																				  *
'*																									  *
'******************************************************************************************************'
Private Sub RegisterNavigator(Nanvigator As SortedMapNavigator)
	NavigatorList.Add(Nanvigator)
End Sub

Private Sub DeregisterNavigator(Nanvigator As SortedMapNavigator)
	Dim NavPosition As Int = NavigatorList.IndexOf(Nanvigator)
	If NavPosition >= 0 Then
		NavigatorList.RemoveAt(NavPosition)
	End If
End Sub

Private Sub InformNavigatorsDeletion(DeletedNode As TreeNode)
	For Each Nav As SortedMapNavigator In NavigatorList
		CallSub2(Nav,"NodeDeleted",DeletedNode)
		
	Next
	
End Sub

Private Sub InformNavigatorsAdd()
	For Each Nav As SortedMapNavigator In NavigatorList
		CallSub(Nav,"NodeAdded")
		
	Next
	
End Sub

Private Sub GetRootNode() As TreeNode
	Return RootNode
	
End Sub

Private Sub GetNullNode() As TreeNode
	Return NullNode
	
End Sub


'******************************************************************************************************'
'*																									  *'
'* Debuging methods. Lists the key in the RB tree in node order from root node                        *'
'*																									  *
'******************************************************************************************************'


Private   Sub ListInOrder()
	ListInorderFromNode(RootNode)
End Sub

Private Sub ListInorderFromNode(Node As TreeNode)
	If Node = NullNode Then
		Return
	End If
	
	ListInorderFromNode(Node.Left)
	Log("Key: " & Node.Key & " Color: " & Node.Color & " Parent: " & Node.Parent.Key & " Left Child: " & Node.Left.Key & " Right Child: "  & Node.Right.Key)
	ListInorderFromNode(Node.Right)
End Sub



 