﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.01
@EndOfDesignText@


'******************************************************************************************************'
'*																									  *'
'* Map Navigation Class                                                                               *'
'*																									  *
'******************************************************************************************************

Sub Class_Globals
Private Const ITERATE_ASCENDING As Int = 2
Private Const ITERATE_DESCENDING As Int = 4
Private RootNode As TreeNode
Private NullNode As TreeNode
Private Direction As Int
Private PrevPositionNode As TreeNode
Private CurrentPositionNode As TreeNode 
Private NextPositionNode As TreeNode
Private IteratationMap As SortedMap
End Sub

'Initalize the iterator. Pass Iterator.MAP_ITERATE_ASCENDING or Iterator.MAP_ITERATE_DECENDING for the direction to It
Public Sub Initialize(MapToIterate As SortedMap,IterationDirection As Int)
	
	IteratationMap = MapToIterate
	RootNode =CallSub(MapToIterate,"GetRootNode")
	NullNode = CallSub(MapToIterate,"GetNullNode")
	
	Direction = IterationDirection
	CurrentPositionNode = NullNode
	If Direction = ITERATE_ASCENDING Then
		NextPositionNode = MinValue(RootNode)
	Else
		NextPositionNode = MaxValue(RootNode)
	End If
    CallSub2(IteratationMap,"RegisterNavigator",Me)
	
End Sub

'Move To The Next Position In The Map. 
Public Sub MoveNext()  As Boolean
 If NextPositionNode <> NullNode Then
	PrevPositionNode = CurrentPositionNode
    CurrentPositionNode = NextPositionNode
	If Direction = ITERATE_ASCENDING Then
			NextPositionNode = InOrderSuccessor(NextPositionNode)
	Else	
			NextPositionNode = InOrderPredescessor(NextPositionNode)
	End If
	Return True
 Else  
	PrevPositionNode = CurrentPositionNode
	CurrentPositionNode = NullNode
    Return False 
 End If

End Sub

'Get the current Key
Public Sub getKey() As Object
	Return CurrentPositionNode.Key
	
End Sub

'Get The Current Value
Public Sub getValue() As Object
	Return CurrentPositionNode.Value
End Sub

'Move to the previous entry. Returns True if succesful.
Public Sub MovePrev()  As Boolean
	If PrevPositionNode <> NullNode Then
		CurrentPositionNode = PrevPositionNode
	    NextPositionNode = CurrentPositionNode
		
		If Direction = ITERATE_ASCENDING Then
			PrevPositionNode = InOrderPredescessor(NextPositionNode)
		Else
			PrevPositionNode = InOrderSuccessor(NextPositionNode)
		End If
    	Return True
	Else
	 NextPositionNode =  CurrentPositionNode
	 CurrentPositionNode = NullNode
	 Return False
	End If
	
End Sub
Private Sub InOrderSuccessor(N As TreeNode)  As TreeNode
	If (N.Right <> NullNode) Then
		Return MinValue(n.Right)
	Else
		Dim Parent As TreeNode = N.Parent
		Do  While Parent <> NullNode And n = Parent.Right
			n = Parent
			Parent = Parent.Parent
		Loop
		Return Parent
	End If
End Sub
 
Private Sub InOrderPredescessor(N As TreeNode)  As TreeNode
	If (N.Left <> NullNode) Then
		Return MaxValue(n.Left)
	Else
		Dim Parent As TreeNode = N.Parent
		Do  While Parent <> NullNode And n = Parent.Left
			n = Parent
			Parent = Parent.Parent
		Loop
		Return Parent
	End If
End Sub

'Reset Map to start position
Public Sub Reset()
CurrentPositionNode = NullNode
If Direction = ITERATE_ASCENDING Then
		NextPositionNode = MinValue(RootNode)
Else
		NextPositionNode = MaxValue(RootNode)
End If
	PrevPositionNode = NullNode
End Sub

'Deregiser
Public Sub Close
	CallSub2(IteratationMap,"DeregisterNavigator",Me)
    RootNode = Null
    NullNode = Null
    PrevPositionNode = Null
    CurrentPositionNode = Null
    NextPositionNode = Null
    IteratationMap = Null
	
	
End Sub
Private Sub MaxValue(N As TreeNode) As TreeNode
	Dim CurrentNode As TreeNode = N
	Do While CurrentNode.Right <> NullNode
		CurrentNode = CurrentNode.Right
	Loop
	Return  CurrentNode
End Sub
Private Sub MinValue(N As TreeNode) As TreeNode
	Dim CurrentNode As TreeNode = N
	Do While CurrentNode.Left <> NullNode
		CurrentNode = CurrentNode.Left
	Loop
	Return  CurrentNode
End Sub

Private Sub NodeDeleted(DeletedNode As TreeNode)
	If PrevPositionNode = DeletedNode Then
		If Direction = ITERATE_ASCENDING Then
			NextPositionNode = InOrderPredescessor(DeletedNode)
	   Else
			NextPositionNode = InOrderSuccessor(DeletedNode)
	   End If
	Else If NextPositionNode = DeletedNode Then 
		If Direction = ITERATE_ASCENDING Then
			NextPositionNode = InOrderSuccessor(DeletedNode)
		Else
			NextPositionNode = InOrderPredescessor(DeletedNode)
	   End If
	Else If CurrentPositionNode = DeletedNode Then
		MoveNext
	End If
End Sub

Private Sub NodeAdded()
	If Direction = ITERATE_ASCENDING Then
		PrevPositionNode = InOrderPredescessor(CurrentPositionNode)
		NextPositionNode = InOrderSuccessor(CurrentPositionNode)
	Else
		PrevPositionNode = InOrderSuccessor(CurrentPositionNode)
		NextPositionNode = InOrderPredescessor(CurrentPositionNode)
	End If
	
End Sub


	
	